#using_animtree("flak88");
init() {

	initArtilleryCvars();
	restrictPlacedArtillery();
	
  level.pak45_hud_bar = "gfx/hud/hud@health_bar.dds";
	precacheShader( "gfx/hud/hud@1pak45.dds" ); //gfx/hud/hud@1pak45.dds
  precacheShader( "gfx/hud/hud@weaponmode_full.dds" );
  precacheShader( "gfx/hud/hud@vehiclehealth.dds" );
  precacheShader( "gfx/hud/hud@health.tga" );
	precacheShader( level.pak45_hud_bar );
	precacheShader( "gfx/hud/tank_reticle25.dds");
	precacheShader( "gfx/hud/tank_reticle50.dds");
	precacheShader( "gfx/hud/tank_reticle75.dds");
	precacheShader( "gfx/hud/tank_reticle100.dds");

	loadfx("fx/explosions/vehicles/t34_mp_n/burn_smoke.efx");
	loadfx("fx/explosions/vehicles/t34_mp_n/1st_exp_v2.efx");
	loadfx("fx/explosions/vehicles/t34_mp_n/2nd_exp.efx");
	loadfx("fx/map_mp/mp_smoke_vehicle_damage.efx");
	loadfx( "fx/vehicle/vehicle_collision.efx" );

	script_vehicles = getentarray ("script_vehicle","classname");
	for (i=0; i<script_vehicles.size; i++) {
		if(script_vehicles[i].vehicletype == getVehicleModelName()) {
			precacheshader("gfx/hud/hud@fire_ready_shell.tga");
			precachevehicle(getVehicleModelName());

			if ((script_vehicles[i].model == "xmodel/mp_artillery_pak45")) {
				precachemodel ("xmodel/mp_artillery_pak45");
				script_vehicles[i].dead_model = ("xmodel/mp_artillery_45_d");
				precachemodel(script_vehicles[i].dead_model);
			}
		}
	}
}

getVehicleModelName() {
	return "pak45_mp";
}

main() {

	wait (0.1);
	script_vehicles = getentarray ("script_vehicle","classname");
	for (i=0;i<script_vehicles.size;i++)	{
		if(script_vehicles[i].vehicletype == getVehicleModelName()) {
      script_vehicles[i].pak45_num = i;
			script_vehicles[i] thread flak_init();
		}
	}
	
}

initArtilleryCvars() {
	
	level.allow_pak45 = getCvar("scr_allow_pak45");
	if(level.allow_pak45 == "")
		level.allow_pak45 = "1";
	setCvar("scr_allow_pak45", level.allow_pak45);
	setCvar("ui_allow_pak45", level.allow_pak45);
	makeCvarServerInfo("ui_allow_pak45",level.allow_pak45);

	if(getCvar("scr_pak45_wait") == "")  // wait time for flak respawn - set higher seconds for longer respawn times
		setCvar("scr_pak45_wait", "120");  //default 120 (2 minutes) - set desired seconds thru console with.../set scr_flak88_wait & amount in seconds...requires map_restart to take effect
	level.pak45_wait = getCvarInt("scr_pak45_wait");
  setCvar("ui_pak45_wait", level.pak45_wait);
	makeCvarServerInfo("ui_pak45_wait", level.pak45_wait);

  if(getCvar("scr_pak45_health") == "")  
		setCvar("scr_pak45_health", "4200");  //default 4200 (light tank shells = 700, about 6 hits to kill it) set desired amount thru console with.../set scr_flak88_health & amount...requires map_restart to take effect
	level.pak45_health = getCvarInt("scr_pak45_health");
  setCvar("ui_pak45_health", level.pak45_health);
	makeCvarServerInfo("ui_pak45_health", level.pak45_health);

}

init_pak_hud() {
	
	self.healthbuffer = 0;
	self.basehealth = getCvarInt("scr_pak45_health");
	self.health = self.basehealth + self.healthbuffer;
	self.currenthealth = self.health;
	self.hud_width = 128;
	self.hud_maxwidth = self.hud_width;
	basewidth = self.hud_width;
	minwidth = 0;

	while(self.hud_width > minwidth) {
		
		self waittill ("damage",amount,attacker,dir,point,mod,inflictor);

		if (level.ceasefire) {
			self.health = self.health + amount;
			continue;
		} 
		if ( !isdefined(inflictor) )
			inflictor = attacker;
			
		owner = self getvehicleowner();
		
		if (isdefined(attacker) && isPlayer(attacker) && isdefined(owner) 
			&& (self != inflictor) && (owner.pers["team"] == attacker.pers["team"])
			&& level.friendlyfire == "0" && getcvar("g_gametype") != "dm" )
		{
			self.health = self.health + amount;
			continue;
		}
			
		self.currenthealth = self.health;
		
		if (!(self.health < self.healthbuffer)) {
			self.hud_width = ((self.health - self.healthbuffer)*basewidth)/self.basehealth;
		} else {
			self.hud_width = 0;
		}

		self notify("pak45_hud_update");
	}

	self.last_attacker = attacker;
	self.last_inflictor = inflictor;	
	
	if ( mod != "MOD_WATER") {

		if (isDefined( attacker )) {
			self DoDamage( 10000, (self.origin[0],self.origin[1],self.origin[2]+25),  attacker, inflictor, mod );
			radiusDamage ( (self.origin[0],self.origin[1],self.origin[2]+180), 450, 500, 20, attacker, inflictor);
		} else {
			self DoDamagemod( 10000, (self.origin[0],self.origin[1],self.origin[2]+25), mod );
			radiusDamage ( (self.origin[0],self.origin[1],self.origin[2]+180), 450, 500, 20, self);
		}
	}	
}

restrictPlacedArtillery() {
	if (level.allow_pak45 != "1") 	{
		deletePlacedEntity(getVehicleModelName());
	}
}

deletePlacedEntity(vehicletype) {
	tanks = getentarray("script_vehicle","classname");

	for(i=0;i<tanks.size;i++) {
		if (tanks[i].vehicletype == vehicletype) {
			tanks[i] delete();
		}
	}
}

flak_think() {
	self endon ("death");

	self thread init_pak_hud();
	self thread pak_death();
	self thread wait_for_activate();
}

flak_init() {
	self endon ("death");

  self.spawn_origin = self.origin;
  self thread effects_init( 1 );
	self.spawn_count = 1;
	self.riding_count = 0;
  self thread pak_respawn();
  
  if (isdefined(getCvar("g_vehicleBurnTime")))
  	self.delay = getCvar("g_vehicleBurnTime");
 	else 
 		self.delay = 10;
 		
	self.health = level.pak45_health;
	
	self thread flak_think();
}

wait_for_activate() {

	self endon("death");

	while (1) {
		wait (0.2);
		self waittill("activated",vehpos,gunner);
		self thread flak_activated_delay(gunner);
	}
}

flak_activated_delay(gunner) {
	wait 0.1;	// wait for a dismount to be processed if on same frame

  reloadicon = newClientHudElem( gunner );
  reloadicon setShader("gfx/hud/hud@1pak45.dds", 32, 14);
	reloadicon.alignX = "left";
	reloadicon.alignY = "top";
	reloadicon.x = 469;  
	reloadicon.y = 442;

  healthbar = newClientHudElem( gunner );
	healthbar.color = (1.5, 0.0, 0.1);
  healthbar setShader(level.pak45_hud_bar, self.hud_width, 8);
	healthbar.alignX = "left";
	healthbar.alignY = "top";
	healthbar.x = 488+13;
  healthbar.y = 446;

	reloadoutline = newClientHudElem( gunner );
	reloadoutline setShader("gfx/hud/hud@vehiclehealth.dds", 128, 32);
	reloadoutline.alignX = "left";
	reloadoutline.alignY = "top";
	reloadoutline.x = 488+13; 
	reloadoutline.y = 452-16;

	fireicon[0] = newClientHudElem(gunner );
	fireicon[0].alignX = "center";
	fireicon[0].alignY = "middle";
	fireicon[0].x = 320;
	fireicon[0].y = 240;
	fireicon[0] setShader("gfx/hud/tank_reticle25.dds", 64, 64);

	fireicon[1] = newClientHudElem(gunner );
	fireicon[1].alignX = "center";
	fireicon[1].alignY = "middle";
	fireicon[1].x = 320;
	fireicon[1].y = 240;
	fireicon[1] setShader("gfx/hud/tank_reticle50.dds", 64, 64);

	fireicon[2] = newClientHudElem(gunner );
	fireicon[2].alignX = "center";
	fireicon[2].alignY = "middle";
	fireicon[2].x = 320;
	fireicon[2].y = 240;
	fireicon[2] setShader("gfx/hud/tank_reticle75.dds", 64, 64);

	fireicon[3] = newClientHudElem(gunner );
	fireicon[3].alignX = "center";
	fireicon[3].alignY = "middle";
	fireicon[3].x = 320;
	fireicon[3].y = 240;
	fireicon[3] setShader("gfx/hud/tank_reticle100.dds", 64, 64);

	for (q=0;q<4;q++) {
		fireicon[q].threaded = 0;
		fireicon[q].alpha = 0;
	}

	level thread flak_hud_destroy_think( self, gunner, fireicon, reloadicon, healthbar, reloadoutline  );

	// wait for the tank to be deactivated
	level thread flak_hud_deactivated_think( self, gunner, fireicon, reloadicon, healthbar,reloadoutline );

	// Incase we want to use this else where.
	self.gunner = gunner; 

	self thread flak_fire_think( fireicon );
	self thread flak_dismount();
  self thread pak_hud_run( gunner, healthbar ); 	
  
}

flak_hud_destroy_think(flak, driver, fireicon, reloadicon, healthbar, reloadoutline) {
	
	driver waittill("stop_pak45_hud");

	if (!isValidPlayer( driver )) {
		// already disconnected, hudelem's must have been destroyed
		return;
	}

  if (isdefined(reloadicon)) reloadicon destroy();
	if (isdefined(reloadoutline)) reloadoutline destroy();
  if (isdefined(healthbar)) healthbar destroy();
            
	if (isdefined(fireicon)) {
		if (isdefined( fireicon[0] )) fireicon[0] destroy();
		if (isdefined( fireicon[1] )) fireicon[1] destroy();
		if (isdefined( fireicon[2] )) fireicon[2] destroy();
		if (isdefined( fireicon[3] )) fireicon[3] destroy();
	}
}

flak_hud_deactivated_think( flak, activator, fireicon, reloadicon, healthbar, reloadoutline ) {
	flak waittill("deactivated", deactivator);
		
	if (!isValidPlayer( activator )) {
		// already disconnected, hudelem's must have been destroyed
		return;
	}

  if (isdefined(reloadicon)) reloadicon destroy();
	if (isdefined(reloadoutline)) reloadoutline destroy();
  if (isdefined(healthbar)) healthbar destroy();

	if (isdefined(fireicon)) {
		if (isdefined( fireicon[0] )) fireicon[0] destroy();
		if (isdefined( fireicon[1] )) fireicon[1] destroy();
		if (isdefined( fireicon[2] )) fireicon[2] destroy();
		if (isdefined( fireicon[3] )) fireicon[3] destroy();
	}
}

flak_dismount() {
	
	self endon("death");
	self waittill("deactivated", activator);
	
	if ( isalive(activator) )
		activator notify("stop_pak45_hud");
}

flak_regen() {
	
	self endon("death");
	
	while (1) {
		self waittill("damage");
		self.health = self.regen_health;		
	}
}

pak_respawn() {
	self waittill("death");

	wait self.delay;
	
	if (!(self.spawnflags & 2) && (!isdefined(self.respawn) || self.respawn == 1)) {
		dupe = self spawnduplicate();
		dupe.spawn_count = self.spawn_count;
		dupe.dead_model = self.dead_model;		
		dupe.spawn_origin = dupe.origin;
		dupe.pak45_num = self.pak45_num;
		dupe thread wait_for_safe_respawn();
		self notify("allow_explode");
	} else {
		self notify("allow_explode");
	}
}

wait_for_safe_respawn(force_respawn) {

	self unlinkfromworld();
	spawn_limit = getCvarInt("scr_vehicle_spawn_limit");
	
	if ( spawn_limit > 0 && self.spawn_count >= spawn_limit )	{
		self delete();
		return;
	}
		
	self.allow_respawn = 1;
		
	if (!isdefined( level.no_auto_vehicle_respawn ) || !level.no_auto_vehicle_respawn) {
		wait level.pak45_wait;
	} 

  if (!isdefined( force_respawn ) || !force_respawn) {
		self.allow_respawn = 0;
	}

	self.waiting_for_respawn = 1;

	while (1) {
		self clearvehicleposition();
		
		if (!isdefined( level.no_auto_vehicle_respawn ) || !level.no_auto_vehicle_respawn) {
			self clearvehicleposition();
			if (self verifyposition())
				break;
		} else {
			if (self.allow_respawn && (self verifyposition())) {
				self clearvehicleposition();
				break;
			}
		}
		
		wait 0.2;
	}
	self.waiting_for_respawn = 0;
	self.spawn_count++;
	self linkintoworld();
	
	if (!isdefined( self.riding_count ))
		self thread flak_init();
}


fadeoff() {
	
	while(self.alpha > 0.0) {
		self.alpha = self.alpha - 0.1;
		wait(0.05);
	}
	self.threaded = 0;
}

flak_fire_think(fireicon) {
	
	self endon("death");
	self endon("deactivated");

	if (!isdefined(fireicon)) return;	//	oh shit


	while (self.health>0) {
		
		self waittill ("turret_fire");

		if(level.ceasefire == 2)
			continue;

		for (q=0;q<4;q++) {
			if ( isdefined( fireicon[q] ) )
				fireicon[q].alpha = 1.0;
		}
		self FireTurret();

		wait .5;
		self playsound ("flak_reload");
	
		while (self isTurretReady() != true) {
			
			val = self get_fire_time() / 1000;
			if (val<=3) {
				if (isdefined( fireicon[val] ) && fireicon[val].threaded == 0) {
					fireicon[val].threaded = 1;
					fireicon[val] thread fadeoff();
				}
			}
			wait .25;
		}
	}
}


//////////////////////////////////////////////////////==pak_effects==//////////////////////////////////////////////////

effects_init( precache ) {

	if (!isdefined( self.dead_model )) {
		println("vehicle unknown, check that vehicle type and model are both lowercase");
		return;
	}

	self thread pak_collision_thread();
}

pak_hud_run(driver, pakHud) {
	self endon("death");
	driver endon("death");
	driver endon("stop_pak45_hud");
	
	minwidth = 0;

	while(1) {
		self waittill("pak45_hud_update");

		if ( !isAlive(self) || !isDefined(pakHud) )
			continue;
			
		if (self.hud_width > minwidth)
			pakHud setShader(level.pak45_hud_bar, self.hud_width, 8);
		else {
			pakHud setShader(level.pak45_hud_bar, minwidth, 8);
			break;
		}
	}
}


pak_collision_thread() {
	self endon("death");
	while (1)	{
		self waittill("vehicle_collision", pos, dir );
		playfx( "fx/vehicle/vehicle_collision.efx", pos, dir );
	}
}

pakPlayFXUntilEvent( fxId, eventStr ) {
	smoke_ent = PlayLoopedFX( fxId, 1, self.origin );
	self waittill( eventStr );
	smoke_ent delete();
}

pak_death() {
	self.deathfx    = loadfx ("fx/explosions/vehicles/t34_mp_n/burn_smoke.efx");
	self.explode1fx = loadfx( "fx/explosions/vehicles/t34_mp_n/1st_exp_v2.efx" );
	self.explode2fx = loadfx( "fx/explosions/vehicles/t34_mp_n/2nd_exp.efx" );
	self waittill( "death" );
      	
  if (!isdefined(self.deepwater)) {
		if (isdefined( self.dead_model ))
			self setmodel( self.dead_model );

		// 1st explode			
		playfxontag( self.explode1fx, self, "tag_origin" );
		earthquake( 0.4, 5, self.origin, 1300 );
		self thread playLoopSoundOnTag("distantfire");
    self thread pakPlayFXUntilEvent( self.deathfx, "allow_explode" );
    self waittill( "allow_explode" );
		println( "recieved allow_explode death");
    self notify ("stop sound distantfire");

		// 2nd explode			
		playfxontag( self.explode2fx, self, "tag_origin" );
		wait 0.5;
		self setcontents(0);	
		radiusDamage ( (self.origin[0],self.origin[1],self.origin[2]+25), 450, 500, 20, self);
	} else {
		println("water death");
		self waittill( "allow_explode" );
	}

	self delete();

}

playLoopSoundOnTag(alias, tag) {
	org = spawn ("script_origin",(0,0,0));
	if (isdefined (tag))
		org linkto (self, tag, (0,0,0), (0,0,0));
	else {
		org.origin = self.origin;
		org.angles = self.angles;
		org linkto (self);
	}
	org playloopsound (alias);
	self waittill ("stop sound " + alias);
	org stoploopsound (alias);
	org delete();
}
